diff --git a/bin/cdist-remote-run b/bin/cdist-remote-run
new file mode 100755
index 00000000..8b3915fc
--- /dev/null
+++ b/bin/cdist-remote-run
@@ -0,0 +1,32 @@
+#!/bin/sh
+#
+# 2011 Nico Schottelius (nico-cdist at schottelius.org)
+#
+# This file is part of cdist.
+#
+# cdist is free software: you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation, either version 3 of the License, or
+# (at your option) any later version.
+#
+# cdist is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with cdist. If not, see .
+#
+#
+# Run a cdist binary on the remote side
+#
+
+. cdist-config
+[ $# -ge 2 ] || __cdist_usage " [opts]"
+set -ue
+
+__cdist_target_host="$1"; shift
+__cdist_remote_binary="$1"; shift
+
+ssh "${__cdist_remote_user}@${__cdist_target_host}" \
+ "PATH=\"${__cdist_remote_bin_dir}:\$PATH\" \"$__cdist_remote_binary\"" "$@"